Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# QCustomEvent Class Reference

The QCustomEvent class provides support for custom events. More...

    #include <QCustomEvent>

Inherits QEvent.

- List of all members, including inherited members
- Compatibility members

### Writable Properties

- 1 writable property inherited from QEvent

### Public Functions

- ~QCustomEvent ()

- 4 public functions inherited from QEvent

## Detailed Description

The QCustomEvent class provides support for custom events.

QCustomEvent is a generic event class for user-defined events. User-defined events can be sent to widgets or other QObject instances using QApplication::postEvent() or QApplication::sendEvent(). Subclasses of QWidget can easily receive custom events by implementing the QWidget::customEvent() event handler function.

QCustomEvent objects should be created with a type ID that uniquely identifies the event type. To avoid clashes with the event types defined in Qt, the value should be at least as large as the value of the "User" entry in the QEvent::Type enum.

QCustomEvent contains a generic `void *` data member that may be used for transferring event-specific data to the receiver. Note that since events are normally delivered asynchronously, the data pointer, if used, must remain valid until the event has been received and processed.

QCustomEvent can be used "as is" for simple user-defined event types, but normally you will want to make a subclass of it for your event types. In a subclass, you can add data members that are suitable for your event type, as in the following example:

        class ColorChangeEvent : public QCustomEvent
        {
        public:
            ColorChangeEvent(QColor color)
                : QCustomEvent(65432), c(color) {}
            QColor color() const { return c; }
        private:
            QColor c;
        };

To send an event of this custom event type:

        ColorChangeEvent *event = new ColorChangeEvent(Qt::blue);
        QApplication::postEvent(receiver, event);
        // Qt will delete the event object

To receive an event of this custom event type:

        void MyWidget::customEvent(QCustomEvent *event)
        {
            if (e->type() == 65432) {  // it must be a ColorChangeEvent
                ColorChangeEvent *colorEvent = (ColorChangeEvent *)event;
                newColor = colorEvent->color();
            }
        }

See also QWidget::customEvent() and QApplication::notify().

## Member Function Documentation

### QCustomEvent::~QCustomEvent ()